Imports Microsoft.VisualBasic
Imports System.Collections.Generic

Friend Class ThreadSafeQueue(Of T)

	Private theLock As Object = New Object()
	Private queue As Queue(Of T) = New Queue(Of T)()

	Public Sub Enqueue(ByVal value As T)
		SyncLock theLock
			queue.Enqueue(value)
		End SyncLock
	End Sub

	Public Function Dequeue() As T
		SyncLock theLock
			Return queue.Dequeue()
		End SyncLock
	End Function

End Class ' class
