Imports Microsoft.VisualBasic
Imports System
Imports System.Linq
Imports System.Threading

Friend Class Program

	Private queue As ThreadSafeQueue(Of Integer) = New ThreadSafeQueue(Of Integer)()

	Public Sub Run(ByVal threadCount As Integer, ByVal threadWork As Integer)

		Dim threads(threadCount - 1) As Thread

		For i As Integer = 0 To threadCount - 1
            threads(i) = New Thread(New ThreadStart(Function() ThreadRun(threadWork)))
			threads(i).Start()
		Next i

		For i As Integer = 0 To threadCount - 1
			threads(i).Join()
		Next i
    End Sub

    Private Function ThreadRun(ByVal threadWork As Integer) As Object
        For i = 1 To threadWork
            queue.Enqueue(1234)
            queue.Dequeue()
        Next
        Return Nothing
    End Function

	Shared Sub Main(ByVal args() As String)
		If args.Length <> 2 Then
			Console.WriteLine("Usage: <# threads> <# push/pop iterations>")

		Else
			Dim threadCount = Integer.Parse(args(0))
			Dim threadWork = Integer.Parse(args(1))

			Console.WriteLine("ThreadSafeQueue threads:{0}  work:{1}", threadCount, threadWork)

			CType(New Program(), Program).Run(threadCount, threadWork)
		End If
	End Sub

End Class ' class
