Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Windows.Media
Imports System.Windows
Imports System.Windows.Data

Namespace SyncView

	Public Class PriorityConverter
		Implements IValueConverter

		Public Function Convert(ByVal value As Object, ByVal targetType As Type, ByVal parameter As Object, ByVal culture As System.Globalization.CultureInfo) As Object Implements IValueConverter.Convert
			If value IsNot Nothing Then
				Dim priority As Integer = CInt(Fix(value))
				Dim colorConverter As New BrushConverter()
				Select Case priority
					Case 0
						Return SystemColors.HighlightBrushKey
					Case 1
						Return Brushes.Green
					Case 2
						Return Brushes.Yellow
					Case 3
						Return Brushes.Red
					Case Else
				End Select
			End If

			Return Nothing
		End Function

		Public Function ConvertBack(ByVal value As Object, ByVal targetType As Type, ByVal parameter As Object, ByVal culture As System.Globalization.CultureInfo) As Object Implements IValueConverter.ConvertBack
			Throw New System.NotImplementedException()
		End Function

	End Class ' class

End Namespace ' namespace
